<?php
add_filter(wpjam_get_filter_name($plugin_page, 'tabs'), function($tabs){
	$bind_actions	= wpjam_get_bind_actions();

	foreach ($bind_actions as $bind_key => $bind_action) {
		$tabs[$bind_key]	= ['title'=>$bind_action['title'],	'function'=>'wpjam_bind_tab_page'];
	}

	return $tabs;
});

function wpjam_bind_tab_page(){
	global $current_tab;

	$bind_actions	= wpjam_get_bind_actions();
	$bind_action	= $bind_actions[$current_tab];
	$signup_model	= $bind_action['model'];
	
	echo '<h2>'.$bind_action['title'].'</h2>';

	$signup_model::bind_form();	
}

function wpjam_phone_bind_page(){
	echo '<h2>手机号码绑定</h2>';

	$user_id	= get_current_user_id();

	$phone		= wpjam_get_user_phone();

	if($phone){
		echo '<div class="card">';
		echo '
		<p>你绑定的手机号码是：<br />
		<strong>'.$phone.'</strong></p>';

		echo '<p>';

		wpjam_ajax_button([
			'action'		=> 'unbind',
			'button_text'	=> '解除绑定',
			'direct'		=> true,
			'confirm'		=> true
		]);

		echo '</p>';

		echo '</div>';
		
	}else{
		$fields = array(
			'phone'		=> array('title'=>'手机号码',	'type'=>'number',	'class'=>'all-options',	'description'=>wpjam_get_ajax_button(['action'=>'code', 'class'=>'button', 'button_text'=>'获取验证码', 'direct'=>true,	'data'=>['phone'=>'']])),
			'code'		=> array('title'=>'验证码',	'type'=>'text',		'class'=>'',	'description'=>'验证码10分钟内有效！'),
		);

		?>
		<style type="text/css">
		.form-table th {width:60px; }
		</style>
		<?php

		wpjam_ajax_form([
			'action'		=> 'bind',
			'fields'		=> $fields,
			'submit_text'	=> '绑定'
		]);
	}

	?>

	<style type="text/css">
		.form-table th{width: 80px;}
	</style>

	<script type="text/javascript">
	jQuery(function($){
		$('#wpjam_button_code').on('click', function(){
			$(this).data('data','phone='+$('input#phone').val());
		});

		$('body').on('page_action_success', function(e, response){
			window.location.reload();
		});
	});
	</script>

	<?php
}

add_filter('wpjam_page_ajax_response', function($ajax_response, $plugin_page, $action){
	global $current_tab;

	$bind_actions	= wpjam_get_bind_actions();
	$bind_action	= $bind_actions[$current_tab];
	$signup_model	= $bind_action['model'];

	$user_id	= get_current_user_id();
	
	if($action == 'bind'){
		$openid = $signup_model::get_user_openid($user_id);	

		if(!$openid){
			wpjam_send_json([
				'errcode'	=> 'scan_fail',
				'errmsg'	=> '请先扫描，再点击刷新。'
			]);
		}else{
			wpjam_send_json();
		}

	}elseif($action == 'unbind'){
		$openid		= $signup_model::get_user_openid($user_id);

		if(!$openid){
			$openid	= $signup_model::get_openid_by_user_id($user_id);
		}

		$signup_model::unbind($user_id, $openid);
		
		wpjam_send_json();
	}elseif($action == 'code'){
		$data	= wp_parse_args($_POST['data']);
		$phone	= $data['phone'] ?? '';

		$response	= wpjam_send_sms(trim($phone));

		if(is_wp_error($response)){
			wpjam_send_json($response);
		}else{
			wpjam_send_json();
		}
	}

}, 10, 3);

add_action('admin_head', function(){
	?>

	<style type="text/css">
	.form-table th{width: 80px;}
	</style>

	<script type="text/javascript">
	jQuery(function($){
		$('body').on('page_action_success', function(e, response){
			window.location.reload();
		});
	});
	</script>

	<?php
});